<?php

/*
	Autorius: Kulverstukas
	Data: 2014.04.15
	Svetainė: http://9v.lt ; Evilzone.org ; Programisiai.lt
*/

/*
    Aprašymas:
        Funkcija tikrina ar žodis baigiasi su nurodyta galūne,
        gražina TRUE jei taip.
*/
function endsWith($haystack, $needle) {
    return $needle === "" || substr($haystack, -strlen($needle)) === $needle;
}

/*
    Aprašymas:
        Funkcija priima vardą arba pavardę (turi būti vienas) ir gražina pakeistą
		į kilmininko linksnį (ko?).

    Pavyzdžiai:
        Drasius Kedys         -> Drasiaus Kedžio
        Dalia Grybauskaitė    -> Dalios Grybauskaitės
        Andrius Kubilius      -> Andriaus Kubiliaus
        Loreta Graužinienė    -> Loretos Graužinienės
        Natalija Bunkė        -> Natalijos Bunkės
*/
function pakeistiVardaKilmininku($str) {
    $rtn = $str;
    $galunes = array(array("as", "o"), array("a", "os"), array("ė", "ės"), array("e", "es"),
                     array("tis", "čio"), array("dis", "džio"), array("dys", "džio"), array("is", "io"),
                     array("ys", "io"), array("us", "aus"));

    for ($i = 0; $i < count($galunes); $i++) {
        if (endsWith($str, $galunes[$i][0])) {
            $rtn = substr($str, 0, strlen($str)-strlen($galunes[$i][0])).$galunes[$i][1];
            break;
        }
    }

    return $rtn;
}

echo pakeistiVardaKilmininku('Drasius'); echo pakeistiVardaKilmininku(' Kedys'); echo '<br />';
echo pakeistiVardaKilmininku('Dalia'); echo pakeistiVardaKilmininku(' Grybauskaitė'); echo '<br />';
echo pakeistiVardaKilmininku('Andrius'); echo pakeistiVardaKilmininku(' Kubilius'); echo '<br />';
echo pakeistiVardaKilmininku('Loreta'); echo pakeistiVardaKilmininku(' Graužinienė'); echo '<br />';
echo pakeistiVardaKilmininku('Natalija'); echo pakeistiVardaKilmininku(' Bunkė'); echo '<br />';

?>