<?php

/*
	Autorius: Kulverstukas
	Data: 2014.04.15
	Svetainė: http://9v.lt ; Evilzone.org ; Programisiai.lt
*/

/*
    Aprašymas:
        Funkcija tikrina ar žodis baigiasi su nurodyta galūne,
        gražina TRUE jei taip.
*/
function endsWith($haystack, $needle) {
    return $needle === "" || substr($haystack, -strlen($needle)) === $needle;
}

/*
    Aprašymas:
        Funkcija priima vardą arba pavardę (turi būti vienas) ir gražina pakeistą
		į naudininko linksnį (kam?).

    Pavyzdžiai:
        Drasius Kedys         -> Drasiui Kedžiui
        Dalia Grybauskaitė    -> Daliai Grybauskaitei
        Andrius Kubilius      -> Andriui Kubiliui
        Loreta Graužinienė    -> Loretai Graužinienei
        Natalija Bunkė        -> Natalijai Bunkei
*/
function pakeistiVardaNaudininku($str) {
    $rtn = $str;
    $galunes = array(array("as", "ui"), array("a", "ai"), array("ė", "ei"), array("e", "ei"),
                     array("tis", "čiui"), array("dys", "džiui"), array("is", "iui"),
                     array("ys", "iui"), array("us", "ui"));

    for ($i = 0; $i < count($galunes); $i++) {
        if (endsWith($str, $galunes[$i][0])) {
            $rtn = substr($str, 0, strlen($str)-strlen($galunes[$i][0])).$galunes[$i][1];
            break;
        }
    }

    return $rtn;
}

echo pakeistiVardaNaudininku('Drasius'); echo pakeistiVardaNaudininku(' Kedys'); echo '<br />';
echo pakeistiVardaNaudininku('Dalia'); echo pakeistiVardaNaudininku(' Grybauskaitė'); echo '<br />';
echo pakeistiVardaNaudininku('Andrius'); echo pakeistiVardaNaudininku(' Kubilius'); echo '<br />';
echo pakeistiVardaNaudininku('Loreta'); echo pakeistiVardaNaudininku(' Graužinienė'); echo '<br />';
echo pakeistiVardaNaudininku('Natalija'); echo pakeistiVardaNaudininku(' Bunkė'); echo '<br />';

?>