<?php

/*
	Autorius: Kulverstukas
	Data: 2014.04.15
	Svetainė: http://9v.lt ; Evilzone.org ; Programisiai.lt
*/

/*
    Aprašymas:
        Funkcija tikrina ar žodis baigiasi su nurodyta galūne,
        gražina TRUE jei taip.
*/
function endsWith($haystack, $needle) {
    return $needle === "" || substr($haystack, -strlen($needle)) === $needle;
}

/*
    Aprašymas:
        Funkcija priima vardą arba pavardę (turi būti vienas) ir gražina pakeistą
		į įnagininko linksnį (kuo?).

    Pavyzdžiai:
        Drasius Kedys         -> Drasium Kedžiu
        Dalia Grybauskaitė    -> Dalia Grybauskaite
        Andrius Kubilius      -> Andrium Kubilium
        Loreta Graužinienė    -> Loreta Graužiniene
        Natalija Bunkė        -> Natalija Bunke
*/
function pakeistiVardaInagininku($str) {
    $rtn = $str;
    $galunes = array(array("as", "u"), array("ė", "e"), array("kis", "kiu"),
                     array("tis", "čiu"), array("dis", "džiu"), array("dys", "džiu"), array("ius", "ium"),
                     array("ys", "iu"));

    for ($i = 0; $i < count($galunes); $i++) {
        if (endsWith($str, $galunes[$i][0])) {
            $rtn = substr($str, 0, strlen($str)-strlen($galunes[$i][0])).$galunes[$i][1];
            break;
        }
    }

    return $rtn;
}

echo pakeistiVardaInagininku('Drasius'); echo pakeistiVardaInagininku(' Kedys'); echo '<br />';
echo pakeistiVardaInagininku('Dalia'); echo pakeistiVardaInagininku(' Grybauskaitė'); echo '<br />';
echo pakeistiVardaInagininku('Andrius'); echo pakeistiVardaInagininku(' Kubilius'); echo '<br />';
echo pakeistiVardaInagininku('Loreta'); echo pakeistiVardaInagininku(' Graužinienė'); echo '<br />';
echo pakeistiVardaInagininku('Natalija'); echo pakeistiVardaInagininku(' Bunkė'); echo '<br />';

?>